'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); // The position data type that stores position info

var _enum = require('../enum');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Position = function () {
    function Position(_ref) {
        var horizontal = _ref.horizontal,
            vertical = _ref.vertical,
            align = _ref.align,
            type = _ref.type,
            margins = _ref.margins;

        _classCallCheck(this, Position);

        this.horizontal = horizontal;
        this.vertical = vertical;
        if (align) this.align = align;
        if (type) this.type = type;
        if (margins) this.margins = margins;
    }

    _createClass(Position, [{
        key: 'iterateDirections',
        value: function iterateDirections(callback) {
            [{
                dir: _enum.direction.horizontal,
                lengths: function (target) {
                    return Object.keys(target).map(function (key) {
                        return target[key];
                    });
                }(this.horizontal)
            }, {
                dir: _enum.direction.vertical,
                lengths: function (target) {
                    return Object.keys(target).map(function (key) {
                        return target[key];
                    });
                }(this.vertical)
            }].forEach(function (_ref2) {
                var dir = _ref2.dir,
                    lengths = _ref2.lengths;

                callback(dir, lengths);
            });
        }
    }, {
        key: 'setDirection',
        value: function setDirection(dir, lengths) {
            this[dir.prop] = {
                before: lengths[0],
                size: lengths[1],
                after: lengths[2]
            };
        }
    }, {
        key: 'isAlignedInDirection',
        value: function isAlignedInDirection(dir) {
            return this.align && this.align === dir;
        }
    }]);

    return Position;
}();

exports.default = Position;